import model.CardValue
import model.Game
import model.Score
import java.util.*

fun main(args: Array<String>) {
    // Get user identity
    var identity: String?
    do {
        println("Bonjour, qui es-tu?")
        identity = readLine()
    } while (identity == null)

    // Create pseudo from identity
    var pseudo = ""

    /* TODO: Uncomment for question extension */
     pseudo = identity.createPseudo()

    println("Bonjour à toi $pseudo, jouons au solitaire")

    // TODO: Uncomment for java -> kotlin
    val score = Score(pseudo, 0, Calendar.getInstance().time)

    // Game loop
    while (true) {
        // Display game
        println(Game)

        // Get user command
        val command = readLine()

        // If command is null, loop
        command?: continue

        // Split command with keyword and arguments
        val splitCommand = command.split(" ")

        // Case of all the different command lengths
        when(splitCommand.size) {
            0 -> continue // Empty command, loop
            1 -> when(splitCommand[0]) {
                "d" -> Game.draw() // Draw new card
                "s" -> Game.store() // Store card on top
            }
            2 -> {
                // Get keyword and differentiate cases
                val (keyWord, param) = splitCommand
                when (keyWord) {
                    "m" -> Game.place(param.toInt()) // Place visible pile top card to a game pile
                    "s" -> Game.store(param.toInt()) // Place game pile top card on store
                }
            }
            3 -> {
                val (keyWord, param1, param2) = splitCommand
                when (keyWord) {
                    "m" -> Game.place(param1.toInt(), param2.toInt())
                }
            }
            4 -> {
                val (keyword, origin, card, target) = splitCommand
                when (keyword) {
                    "m" -> Game.move(origin.toInt(), CardValue.fromString(card), target.toInt())
                }
            }
        }
        // TODO uncomment java -> kotlin traduction
        score.commandsUsed += 1
        println("Player: ${score.playerName} Turns:${score.commandsUsed} StartTime:${score.startTime}")
    }
}